######################
# ONI TEAM ARENA 1.0 #
######################
# arena_rand.bsl for airport
###############################

################ RANDOM VARIABLES (CORE)
var int rand_cell= 0; var int rand_ammo= 0;
var int rand_invis= 0; var int rand_shield= 0;
var int rand_dead= 0; var int rand_weapon= 0;
var int rand_flag= 0; var int rand_music= 0;
################ THEIR MAX VALUES (CUSTOM)
######## POWERUPS, WEAPONS AND DEATH MESSAGES (LEVEL-INDEPENDENT)
var int rand_cell_max= 6; var int rand_ammo_max= 7;
var int rand_invis_max= 98; var int rand_shield_max= 99;
var int rand_dead_max= 22; var int rand_weapon_max= 14;
######## TELEPORT FLAG (LEVEL- AND AREA-DEPENDENT)
var int rand_flag_max= 28;
######## MUSIC (LEVEL-DEPENDENT)
var int rand_music_max= 3;
################ AUXILIARY VARIABLES (CORE)
var string now_playing; var string next_tune;
var string rand_weapon_name;
###################################################################
################ JUKEBOX (CORE)
func void ArenaMusic(void) {
	sleep 400; now_playing= next_tune; sound_music_start(now_playing);
	sleep 6000; sound_music_stop(now_playing); fork ArenaMusic();
}
################ RANDOMIZER INITIALIZATION (CUSTOM, AREA-SPECIFIC)
func void RandInit(void) {
	rand_cell_max= 6; rand_shield_max= 99;
	rand_ammo_max= 7; rand_invis_max= 98;
	rand_dead_max= 22; rand_weapon_max= 14;
	rand_music_max= 4; ArenaResetFlags();

	now_playing= mus_asian; next_tune= mus_asian;
	rand_weapon_name= w6_vdg;
	fork RandGen();
}
func ArenaResetFlags {
	if(arena_area eq 0) rand_flag_max= 21;
	if(arena_area eq 1) rand_flag_max= 22;
	if(arena_area eq 2) rand_flag_max= 28;
}
################ RANDOM NUMBER GENERATOR (CORE)
func void RandGen(void) {
	rand_cell= rand_cell + 1; if(rand_cell > rand_cell_max) rand_cell= 0;
	rand_ammo= rand_ammo + 1; if(rand_ammo > rand_ammo_max) rand_ammo= 0;
	rand_invis= rand_invis + 1; if(rand_invis > rand_invis_max) rand_invis= 0;
	rand_shield= rand_shield + 1; if(rand_shield > rand_shield_max) rand_shield= 0;
	rand_dead= rand_dead + 1; if(rand_dead > rand_dead_max) rand_dead= 0;
	rand_weapon= rand_weapon + 1; if(rand_weapon > rand_weapon_max) rand_weapon= 0
	rand_flag= rand_flag + 1; if(rand_flag > rand_flag_max) rand_flag= 0;
	rand_music= rand_music + 1; if(rand_music > rand_music_max) rand_music= 0;
	sleep 1; fork RandGen();
}
################ CLIENT FUNCTIONS (CUSTOM)
######## POWERUPS (LEVEL-INDEPENDENT)
func void GiveRandPowerups(string ai_name) {
	if(rand_shield > 95) chr_givepowerup(ai_name, shield);
	if(rand_invis  > 95) chr_givepowerup(ai_name, invis);
	chr_givepowerup(ai_name, cell, rand_cell);
	chr_givepowerup(ai_name, ammo, rand_ammo);
}
######## MUSIC FILES (LEVEL-DEPENDENT)
func void RandMusic(void) {
	if(rand_music eq 0) next_tune= mus_asian;
	if(rand_music eq 1) next_tune= mus_fitec;
	if(rand_music eq 2) next_tune= mus_fiteb;
	if(rand_music eq 3) next_tune= mus_fitec_hd;
	if(rand_music eq 4) next_tune= atm_gr06;
	if(next_tune eq now_playing and now_playing ne mus_main03) next_tune= mus_main03;
}
######## WEAPONS (LEVEL-INDEPENDENT)
func void RandWeapon(void) {
	if(rand_weapon eq  0) rand_weapon_name=  w6_vdg;
	if(rand_weapon eq  1) rand_weapon_name=  w3_phr;
	if(rand_weapon eq  2) rand_weapon_name=  w7_scc;
	if(rand_weapon eq  3) rand_weapon_name=  w1_tap;
	if(rand_weapon eq  4) rand_weapon_name=  w2_sap;
	if(rand_weapon eq  5) rand_weapon_name=  w3_phr;
	if(rand_weapon eq  6) rand_weapon_name=  w4_psm;
	if(rand_weapon eq  7) rand_weapon_name=  w5_sbg;
	if(rand_weapon eq  8) rand_weapon_name=  w6_vdg;
	if(rand_weapon eq  9) rand_weapon_name=  w7_scc;
	if(rand_weapon eq 10) rand_weapon_name=  w8_mbo;
	if(rand_weapon eq 11) rand_weapon_name=  w9_scr;
	if(rand_weapon eq 12) rand_weapon_name=  w8_mbo;
	if(rand_weapon eq 13) rand_weapon_name= w11_ba1;
	if(rand_weapon eq 14) rand_weapon_name=  w4_psm;
}
######## TELEPORT FLAGS (LEVEL- AND AREA-DEPENDENT)
func void SendToRandFlag(string ai_name, string ai_team) {
	if(arena_area eq 0) {
################AIRPORT: REPAIR BAY
		if(rand_flag eq  0)
			{chr_teleport(ai_name,   1116); chr_facetoflag(ai_name,   1116);}
		if(rand_flag eq  1)
			{chr_teleport(ai_name,   1117); chr_facetoflag(ai_name,   1117);}
		if(rand_flag eq  2)
			{chr_teleport(ai_name,   1118); chr_facetoflag(ai_name,   1118);}
		if(rand_flag eq  3)
			{chr_teleport(ai_name,   1119); chr_facetoflag(ai_name,   1119);}
		if(rand_flag eq  4)
			{chr_teleport(ai_name,   1120); chr_facetoflag(ai_name,   1120);}
		if(rand_flag eq  5)
			{chr_teleport(ai_name,   1121); chr_facetoflag(ai_name,   1121);}
		if(rand_flag eq  6)
			{chr_teleport(ai_name,   1122); chr_facetoflag(ai_name,   1122);}
		if(rand_flag eq  7)
			{chr_teleport(ai_name,   1123); chr_facetoflag(ai_name,   1123);}
		if(rand_flag eq  8)
			{chr_teleport(ai_name,   1124); chr_facetoflag(ai_name,   1124);}
		if(rand_flag eq  9)
			{chr_teleport(ai_name,   1125); chr_facetoflag(ai_name,   1125);}
		if(rand_flag eq 10)
			{chr_teleport(ai_name,   1126); chr_facetoflag(ai_name,   1126);}
		if(rand_flag eq 11)
			{chr_teleport(ai_name,   1127); chr_facetoflag(ai_name,   1127);}
		if(rand_flag eq 12)
			{chr_teleport(ai_name,   1128); chr_facetoflag(ai_name,   1128);}
		if(rand_flag eq 13)
			{chr_teleport(ai_name,   1129); chr_facetoflag(ai_name,   1129);}
		if(rand_flag eq 14)
			{chr_teleport(ai_name,   1130); chr_facetoflag(ai_name,   1130);}
		if(rand_flag eq 15)
			{chr_teleport(ai_name,   1131); chr_facetoflag(ai_name,   1131);}
		if(rand_flag eq 16)
			{chr_teleport(ai_name,   1141); chr_facetoflag(ai_name,   1141);}
		if(rand_flag eq 17)
			{chr_teleport(ai_name,  7023); chr_facetoflag(ai_name,  7023);}
		if(rand_flag eq 18)
			{chr_teleport(ai_name,  7024); chr_facetoflag(ai_name,  7024);}
		if(rand_flag eq 19)
			{chr_teleport(ai_name,  7025); chr_facetoflag(ai_name,  7025);}
		if(rand_flag eq 20)
			{chr_teleport(ai_name,  7026); chr_facetoflag(ai_name,  7026);}
		if(rand_flag > 20)
			{chr_teleport(ai_name, 7028); chr_facetoflag(ai_name, 7028);}
	}
	if(arena_area eq 1) {
################ ENTRANCE AREA
		if(rand_flag eq  0)
			{chr_teleport(ai_name, 100); chr_facetoflag(ai_name, 100);}
		if(rand_flag eq  1)
			{chr_teleport(ai_name, 101); chr_facetoflag(ai_name, 101);}
		if(rand_flag eq  2)
			{chr_teleport(ai_name, 102); chr_facetoflag(ai_name, 102);}
		if(rand_flag eq  3)
			{chr_teleport(ai_name, 105); chr_facetoflag(ai_name, 105);}
		if(rand_flag eq  4)
			{chr_teleport(ai_name, 1000); chr_facetoflag(ai_name, 1000);}
		if(rand_flag eq  5)
			{chr_teleport(ai_name, 1016); chr_facetoflag(ai_name, 1016);}
		if(rand_flag eq  6)
			{chr_teleport(ai_name, 1017); chr_facetoflag(ai_name, 1017);}
		if(rand_flag eq  7)
			{chr_teleport(ai_name, 1018); chr_facetoflag(ai_name, 1018);}
		if(rand_flag eq  8)
			{chr_teleport(ai_name, 1019); chr_facetoflag(ai_name, 1019);}
		if(rand_flag eq  9)
			{chr_teleport(ai_name, 1020); chr_facetoflag(ai_name, 1020);}
		if(rand_flag eq 10)
			{chr_teleport(ai_name, 1021); chr_facetoflag(ai_name, 1021);}
		if(rand_flag eq 11)
			{chr_teleport(ai_name, 1022); chr_facetoflag(ai_name, 1022);}
		if(rand_flag eq 12)
			{chr_teleport(ai_name, 1023); chr_facetoflag(ai_name, 1023);}
		if(rand_flag eq 13)
			{chr_teleport(ai_name, 1024); chr_facetoflag(ai_name, 1024);}
		if(rand_flag eq 14)
			{chr_teleport(ai_name, 1025); chr_facetoflag(ai_name, 1025);}
		if(rand_flag eq 15)
			{chr_teleport(ai_name, 1026); chr_facetoflag(ai_name, 1026);}
		if(rand_flag eq 16)
			{chr_teleport(ai_name, 7000); chr_facetoflag(ai_name, 7000);}
		if(rand_flag eq 17)
			{chr_teleport(ai_name, 7001); chr_facetoflag(ai_name, 7001);}
		if(rand_flag eq 18)
			{chr_teleport(ai_name, 7002); chr_facetoflag(ai_name, 7002);}
		if(rand_flag eq 19)
			{chr_teleport(ai_name, 7011); chr_facetoflag(ai_name, 7011);}
		if(rand_flag eq 20)
			{chr_teleport(ai_name, 7022); chr_facetoflag(ai_name, 7022);}
		if(rand_flag eq 21)
			{chr_teleport(ai_name, 7038); chr_facetoflag(ai_name, 7038);}
		if(rand_flag >  21)
			{chr_teleport(ai_name, 7059); chr_facetoflag(ai_name, 7059);}
}
	if(arena_area eq 2) {
################ HUGE OUTSIDE AREA AND RAMPS
		if(rand_flag eq  0)
			{chr_teleport(ai_name,    1132); chr_facetoflag(ai_name,    1132);}
		if(rand_flag eq  1)
			{chr_teleport(ai_name,   1133); chr_facetoflag(ai_name,   1133);}
		if(rand_flag eq  2)
			{chr_teleport(ai_name,   1134); chr_facetoflag(ai_name,   1134);}
		if(rand_flag eq  3)
			{chr_teleport(ai_name,   1135); chr_facetoflag(ai_name,   1135);}
		if(rand_flag eq  4)
			{chr_teleport(ai_name,   1137); chr_facetoflag(ai_name,   1137);}
		if(rand_flag eq  5)
			{chr_teleport(ai_name,   1138); chr_facetoflag(ai_name,   1138);}
		if(rand_flag eq  6)
			{chr_teleport(ai_name,   1142); chr_facetoflag(ai_name,   1142);}
		if(rand_flag eq  7)
			{chr_teleport(ai_name,   7005); chr_facetoflag(ai_name,   7005);}
		if(rand_flag eq  8)
			{chr_teleport(ai_name,   7007); chr_facetoflag(ai_name,   7007);}
		if(rand_flag eq  9)
			{chr_teleport(ai_name,   1100); chr_facetoflag(ai_name,   1100);}
		if(rand_flag eq 10)
			{chr_teleport(ai_name,   1101); chr_facetoflag(ai_name,   1101);}
		if(rand_flag eq 11)
			{chr_teleport(ai_name,   1102); chr_facetoflag(ai_name,   1102);}
		if(rand_flag eq 12)
			{chr_teleport(ai_name,   1103); chr_facetoflag(ai_name,   1103);}
		if(rand_flag eq 13)
			{chr_teleport(ai_name,  1104); chr_facetoflag(ai_name,  1104);}
		if(rand_flag eq 14)
			{chr_teleport(ai_name,  1105); chr_facetoflag(ai_name,  1105);}
		if(rand_flag eq 15)
			{chr_teleport(ai_name,  1106); chr_facetoflag(ai_name,  1106);}
		if(rand_flag eq 16)
			{chr_teleport(ai_name,  1107); chr_facetoflag(ai_name,  1107);}
		if(rand_flag eq 17)
			{chr_teleport(ai_name,  1108); chr_facetoflag(ai_name,  1108);}
		if(rand_flag eq 18)
			{chr_teleport(ai_name,  1109); chr_facetoflag(ai_name,  1109);}
		if(rand_flag eq 19)
			{chr_teleport(ai_name,  1110); chr_facetoflag(ai_name,  1110);}
		if(rand_flag eq 20)
			{chr_teleport(ai_name, 1111); chr_facetoflag(ai_name, 1111);}
		if(rand_flag eq 21)
			{chr_teleport(ai_name, 1112); chr_facetoflag(ai_name, 1112);}
		if(rand_flag eq 22)
			{chr_teleport(ai_name, 7031); chr_facetoflag(ai_name, 7031);}
		if(rand_flag eq 23)
			{chr_teleport(ai_name,   7032); chr_facetoflag(ai_name,   7032);}
		if(rand_flag eq 24)
			{chr_teleport(ai_name,   7033); chr_facetoflag(ai_name,   7033);}
		if(rand_flag eq 25)
			{chr_teleport(ai_name,   7046); chr_facetoflag(ai_name,   7046);}
		if(rand_flag eq 26)
			{chr_teleport(ai_name,   7047); chr_facetoflag(ai_name,   7047);}
		if(rand_flag eq 27)
			{chr_teleport(ai_name,   7055); chr_facetoflag(ai_name,   7055);}
		if(rand_flag >  27)
			{chr_teleport(ai_name,   7056); chr_facetoflag(ai_name,   7056);}
	}
	chr_animate(ai_name, NINCOMteleport_out);
}
######## DEATH MESSAGES (LEVEL-INDEPENDENT)
func RandDead {
	if(rand_dead eq  0) dmsg "is dead"
	if(rand_dead eq  1) dmsg "is no more"
	if(rand_dead eq  2) dmsg "has ceased to be"
	if(rand_dead eq  3) dmsg "has expired"
	if(rand_dead eq  4) dmsg "is history"
	if(rand_dead eq  5) dmsg "has been neutralized"
	if(rand_dead eq  6) dmsg "has been annihilated"
	if(rand_dead eq  7) dmsg "has died"
	if(rand_dead eq  8) dmsg "has turned to dust"
	if(rand_dead eq  9) dmsg "has bitten the dust"
	if(rand_dead eq 10) dmsg "has gone"
	if(rand_dead eq 11) dmsg "will come back"
	if(rand_dead eq 12) dmsg "has been obliterated"
	if(rand_dead eq 13) dmsg "has been destroyed"
	if(rand_dead eq 14) dmsg "has been wiped out"
	if(rand_dead eq 15) dmsg "is a stiff"
	if(rand_dead eq 16) dmsg "has passed on"
	if(rand_dead eq 17) dmsg "has been destroyed"
	if(rand_dead eq 18) dmsg "is late"
	if(rand_dead eq 19) dmsg "rests in peace"
	if(rand_dead eq 20) dmsg "is bereft of life"
	if(rand_dead eq 21) dmsg "is deceased"
	if(rand_dead eq 22) dmsg "is demised"
	if(rand_dead >  22) dmsg "is dead"
}
