######################
# ONI TEAM ARENA 1.0 #
######################
# arena_rand.bsl for tctf_ii
###############################

################ RANDOM VARIABLES (CORE)
var int rand_cell= 0; var int rand_ammo= 0;
var int rand_invis= 0; var int rand_shield= 0;
var int rand_dead= 0; var int rand_weapon= 0;
var int rand_flag= 0; var int rand_music= 0;
################ THEIR MAX VALUES (CUSTOM)
######## POWERUPS, WEAPONS AND DEATH MESSAGES (LEVEL-INDEPENDENT)
var int rand_cell_max= 6; var int rand_ammo_max= 7;
var int rand_invis_max= 98; var int rand_shield_max= 99;
var int rand_dead_max= 22; var int rand_weapon_max= 14;
######## TELEPORT FLAG (LEVEL- AND AREA-DEPENDENT)
var int rand_flag_max= 38;
######## MUSIC (LEVEL-DEPENDENT)
var int rand_music_max= 3;
################ AUXILIARY VARIABLES (CORE)
var string now_playing; var string next_tune;
var string rand_weapon_name;
###################################################################
################ JUKEBOX (CORE)
func void ArenaMusic(void) {
	sleep 400; now_playing= next_tune; sound_music_start(now_playing);
	sleep 6000; sound_music_stop(now_playing); fork ArenaMusic();
}
################ RANDOMIZER INITIALIZATION (CUSTOM, AREA-SPECIFIC)
func void RandInit(void) {
	rand_cell_max= 6; rand_shield_max= 99;
	rand_ammo_max= 7; rand_invis_max= 98;
	rand_dead_max= 22; rand_weapon_max= 14;
	rand_music_max= 3; ArenaResetFlags();

	now_playing= mus_main03; next_tune= mus_main03;
	rand_weapon_name= w6_vdg;
	fork RandGen();
}
func ArenaResetFlags {
	if(arena_area eq 0) rand_flag_max= 21;
	if(arena_area eq 1) rand_flag_max= 22;
	if(arena_area eq 2) rand_flag_max= 38;
}
################ RANDOM NUMBER GENERATOR (CORE)
func void RandGen(void) {
	rand_cell= rand_cell + 1; if(rand_cell > rand_cell_max) rand_cell= 0;
	rand_ammo= rand_ammo + 1; if(rand_ammo > rand_ammo_max) rand_ammo= 0;
	rand_invis= rand_invis + 1; if(rand_invis > rand_invis_max) rand_invis= 0;
	rand_shield= rand_shield + 1; if(rand_shield > rand_shield_max) rand_shield= 0;
	rand_dead= rand_dead + 1; if(rand_dead > rand_dead_max) rand_dead= 0;
	rand_weapon= rand_weapon + 1; if(rand_weapon > rand_weapon_max) rand_weapon= 0
	rand_flag= rand_flag + 1; if(rand_flag > rand_flag_max) rand_flag= 0;
	rand_music= rand_music + 1; if(rand_music > rand_music_max) rand_music= 0;
	sleep 1; fork RandGen();
}
################ CLIENT FUNCTIONS (CUSTOM)
######## POWERUPS (LEVEL-INDEPENDENT)
func void GiveRandPowerups(string ai_name) {
	if(rand_shield > 95) chr_givepowerup(ai_name, shield);
	if(rand_invis  > 95) chr_givepowerup(ai_name, invis);
	chr_givepowerup(ai_name, cell, rand_cell);
	chr_givepowerup(ai_name, ammo, rand_ammo);
}
######## MUSIC FILES (LEVEL-DEPENDENT)
func void RandMusic(void) {
	if(rand_music eq 0) next_tune= mus_main03;
	if(rand_music eq 1) next_tune= mus_wls;
	if(rand_music eq 2) next_tune= mus_trt;
	if(rand_music eq 3) next_tune= mus_sv;
	if(next_tune eq now_playing and now_playing ne mus_main03) next_tune= mus_main03;
}
######## WEAPONS (LEVEL-INDEPENDENT)
func void RandWeapon(void) {
	if(rand_weapon eq  0) rand_weapon_name=  w6_vdg;
	if(rand_weapon eq  1) rand_weapon_name=  w3_phr;
	if(rand_weapon eq  2) rand_weapon_name=  w7_scc;
	if(rand_weapon eq  3) rand_weapon_name=  w1_tap;
	if(rand_weapon eq  4) rand_weapon_name=  w2_sap;
	if(rand_weapon eq  5) rand_weapon_name=  w3_phr;
	if(rand_weapon eq  6) rand_weapon_name=  w4_psm;
	if(rand_weapon eq  7) rand_weapon_name=  w5_sbg;
	if(rand_weapon eq  8) rand_weapon_name=  w6_vdg;
	if(rand_weapon eq  9) rand_weapon_name=  w7_scc;
	if(rand_weapon eq 10) rand_weapon_name=  w8_mbo;
	if(rand_weapon eq 11) rand_weapon_name=  w9_scr;
	if(rand_weapon eq 12) rand_weapon_name=  w8_mbo;
	if(rand_weapon eq 13) rand_weapon_name= w11_ba1;
	if(rand_weapon eq 14) rand_weapon_name=  w4_psm;
}
######## TELEPORT FLAGS (LEVEL- AND AREA-DEPENDENT)
func void SendToRandFlag(string ai_name, string ai_team) {
	if(arena_area eq 0) {
################ TCTF : DAMOCLES
		if(rand_flag eq  0)
			{chr_teleport(ai_name,   63); chr_facetoflag(ai_name,   63);}
		if(rand_flag eq  1)
			{chr_teleport(ai_name,   64); chr_facetoflag(ai_name,   64);}
		if(rand_flag eq  2)
			{chr_teleport(ai_name,   65); chr_facetoflag(ai_name,   65);}
		if(rand_flag eq  3)
			{chr_teleport(ai_name,   66); chr_facetoflag(ai_name,   66);}
		if(rand_flag eq  4)
			{chr_teleport(ai_name,   70); chr_facetoflag(ai_name,   70);}
		if(rand_flag eq  5)
			{chr_teleport(ai_name,   71); chr_facetoflag(ai_name,   71);}
		if(rand_flag eq  6)
			{chr_teleport(ai_name,   72); chr_facetoflag(ai_name,   72);}
		if(rand_flag eq  7)
			{chr_teleport(ai_name,   74); chr_facetoflag(ai_name,   74);}
		if(rand_flag eq  8)
			{chr_teleport(ai_name,   75); chr_facetoflag(ai_name,   75);}
		if(rand_flag eq  9)
			{chr_teleport(ai_name,   76); chr_facetoflag(ai_name,   76);}
		if(rand_flag eq 10)
			{chr_teleport(ai_name,   77); chr_facetoflag(ai_name,   77);}
		if(rand_flag eq 11)
			{chr_teleport(ai_name,   408); chr_facetoflag(ai_name,   408);}
		if(rand_flag eq 12)
			{chr_teleport(ai_name,   409); chr_facetoflag(ai_name,   409);}
		if(rand_flag eq 13)
			{chr_teleport(ai_name,   410); chr_facetoflag(ai_name,   410);}
		if(rand_flag eq 14)
			{chr_teleport(ai_name,   411); chr_facetoflag(ai_name,   411);}
		if(rand_flag eq 15)
			{chr_teleport(ai_name,   611); chr_facetoflag(ai_name,   611);}
		if(rand_flag eq 16)
			{chr_teleport(ai_name,   612); chr_facetoflag(ai_name,   612);}
		if(rand_flag eq 17)
			{chr_teleport(ai_name,  778); chr_facetoflag(ai_name,  778);}
		if(rand_flag eq 18)
			{chr_teleport(ai_name,  779); chr_facetoflag(ai_name,  779);}
		if(rand_flag eq 19)
			{chr_teleport(ai_name,  780); chr_facetoflag(ai_name,  780);}
		if(rand_flag eq 20)
			{chr_teleport(ai_name,  781); chr_facetoflag(ai_name,  781);}
		if(rand_flag > 20)
			{chr_teleport(ai_name, 68); chr_facetoflag(ai_name, 68);}
	}
	if(arena_area eq 1) {
################ ATRIUM AREA
		if(rand_flag eq  0)
			{chr_teleport(ai_name, 2); chr_facetoflag(ai_name, 2);}
		if(rand_flag eq  1)
			{chr_teleport(ai_name, 600); chr_facetoflag(ai_name, 600);}
		if(rand_flag eq  2)
			{chr_teleport(ai_name, 700); chr_facetoflag(ai_name, 700);}
		if(rand_flag eq  3)
			{chr_teleport(ai_name, 701); chr_facetoflag(ai_name, 701);}
		if(rand_flag eq  4)
			{chr_teleport(ai_name, 702); chr_facetoflag(ai_name, 702);}
		if(rand_flag eq  5)
			{chr_teleport(ai_name, 703); chr_facetoflag(ai_name, 703);}
		if(rand_flag eq  6)
			{chr_teleport(ai_name, 704); chr_facetoflag(ai_name, 704);}
		if(rand_flag eq  7)
			{chr_teleport(ai_name, 705); chr_facetoflag(ai_name, 705);}
		if(rand_flag eq  8)
			{chr_teleport(ai_name, 706); chr_facetoflag(ai_name, 706);}
		if(rand_flag eq  9)
			{chr_teleport(ai_name, 707); chr_facetoflag(ai_name, 707);}
		if(rand_flag eq 10)
			{chr_teleport(ai_name, 782); chr_facetoflag(ai_name, 782);}
		if(rand_flag eq 11)
			{chr_teleport(ai_name, 790); chr_facetoflag(ai_name, 790);}
		if(rand_flag eq 12)
			{chr_teleport(ai_name, 791); chr_facetoflag(ai_name, 791);}
		if(rand_flag eq 13)
			{chr_teleport(ai_name, 795); chr_facetoflag(ai_name, 795);}
		if(rand_flag eq 14)
			{chr_teleport(ai_name, 796); chr_facetoflag(ai_name, 796);}
		if(rand_flag eq 15)
			{chr_teleport(ai_name, 797); chr_facetoflag(ai_name, 797);}
		if(rand_flag eq 16)
			{chr_teleport(ai_name, 798); chr_facetoflag(ai_name, 798);}
		if(rand_flag eq 17)
			{chr_teleport(ai_name, 799); chr_facetoflag(ai_name, 799);}
		if(rand_flag eq 18)
			{chr_teleport(ai_name, 800); chr_facetoflag(ai_name, 800);}
		if(rand_flag eq 19)
			{chr_teleport(ai_name, 801); chr_facetoflag(ai_name, 801);}
		if(rand_flag eq 20)
			{chr_teleport(ai_name, 805); chr_facetoflag(ai_name, 805);}
		if(rand_flag eq 21)
			{chr_teleport(ai_name, 810); chr_facetoflag(ai_name, 810);}
		if(rand_flag >  21)
			{chr_teleport(ai_name, 888); chr_facetoflag(ai_name, 888);}
}
	if(arena_area eq 2) {
################ HUGE TOP AREA
		if(rand_flag eq  0)
			{chr_teleport(ai_name,    3); chr_facetoflag(ai_name,    3);}
		if(rand_flag eq  1)
			{chr_teleport(ai_name,   4); chr_facetoflag(ai_name,   4);}
		if(rand_flag eq  2)
			{chr_teleport(ai_name,   5); chr_facetoflag(ai_name,   5);}
		if(rand_flag eq  3)
			{chr_teleport(ai_name,   6); chr_facetoflag(ai_name,   6);}
		if(rand_flag eq  4)
			{chr_teleport(ai_name,   7); chr_facetoflag(ai_name,   7);}
		if(rand_flag eq  5)
			{chr_teleport(ai_name,   8); chr_facetoflag(ai_name,   8);}
		if(rand_flag eq  6)
			{chr_teleport(ai_name,   9); chr_facetoflag(ai_name,   9);}
		if(rand_flag eq  7)
			{chr_teleport(ai_name,   10); chr_facetoflag(ai_name,   10);}
		if(rand_flag eq  8)
			{chr_teleport(ai_name,   11); chr_facetoflag(ai_name,   11);}
		if(rand_flag eq  9)
			{chr_teleport(ai_name,   12); chr_facetoflag(ai_name,   12);}
		if(rand_flag eq 10)
			{chr_teleport(ai_name,   16); chr_facetoflag(ai_name,   16);}
		if(rand_flag eq 11)
			{chr_teleport(ai_name,   17); chr_facetoflag(ai_name,   17);}
		if(rand_flag eq 12)
			{chr_teleport(ai_name,   18); chr_facetoflag(ai_name,   18);}
		if(rand_flag eq 13)
			{chr_teleport(ai_name,  20); chr_facetoflag(ai_name,  20);}
		if(rand_flag eq 14)
			{chr_teleport(ai_name,  21); chr_facetoflag(ai_name,  21);}
		if(rand_flag eq 15)
			{chr_teleport(ai_name,  22); chr_facetoflag(ai_name,  22);}
		if(rand_flag eq 16)
			{chr_teleport(ai_name,  26); chr_facetoflag(ai_name,  26);}
		if(rand_flag eq 17)
			{chr_teleport(ai_name,  27); chr_facetoflag(ai_name,  27);}
		if(rand_flag eq 18)
			{chr_teleport(ai_name,  28); chr_facetoflag(ai_name,  28);}
		if(rand_flag eq 19)
			{chr_teleport(ai_name,  29); chr_facetoflag(ai_name,  29);}
		if(rand_flag eq 20)
			{chr_teleport(ai_name, 30); chr_facetoflag(ai_name, 30);}
		if(rand_flag eq 21)
			{chr_teleport(ai_name, 31); chr_facetoflag(ai_name, 31);}
		if(rand_flag eq 22)
			{chr_teleport(ai_name, 32); chr_facetoflag(ai_name, 32);}
		if(rand_flag eq 23)
			{chr_teleport(ai_name,   33); chr_facetoflag(ai_name,   33);}
		if(rand_flag eq 24)
			{chr_teleport(ai_name,   34); chr_facetoflag(ai_name,   34);}
		if(rand_flag eq 25)
			{chr_teleport(ai_name,   35); chr_facetoflag(ai_name,   35);}
		if(rand_flag eq 26)
			{chr_teleport(ai_name,   36); chr_facetoflag(ai_name,   36);}
		if(rand_flag eq 27)
			{chr_teleport(ai_name,   37); chr_facetoflag(ai_name,   37);}
		if(rand_flag eq 28)
			{chr_teleport(ai_name,   38); chr_facetoflag(ai_name,   38);}
		if(rand_flag eq 29)
			{chr_teleport(ai_name,   39); chr_facetoflag(ai_name,   39);}
		if(rand_flag eq 30)
			{chr_teleport(ai_name,   40); chr_facetoflag(ai_name,   40);}
		if(rand_flag eq 31)
			{chr_teleport(ai_name,   41); chr_facetoflag(ai_name,   41);}
		if(rand_flag eq  32)
			{chr_teleport(ai_name,  42); chr_facetoflag(ai_name,  42);}
		if(rand_flag eq  33)
			{chr_teleport(ai_name,  43); chr_facetoflag(ai_name,  43);}
		if(rand_flag eq  34)
			{chr_teleport(ai_name,  44); chr_facetoflag(ai_name,  44);}
		if(rand_flag eq  35)
			{chr_teleport(ai_name,  45); chr_facetoflag(ai_name,  45);}
		if(rand_flag eq  36)
			{chr_teleport(ai_name,  46); chr_facetoflag(ai_name,  46);}
		if(rand_flag eq  37)
			{chr_teleport(ai_name,  47); chr_facetoflag(ai_name,  47);}
		if(rand_flag >  37)
			{chr_teleport(ai_name,  48); chr_facetoflag(ai_name,  48);}
	}
	chr_animate(ai_name, NINCOMteleport_out);
}
######## DEATH MESSAGES (LEVEL-INDEPENDENT)
func RandDead {
	if(rand_dead eq  0) dmsg "is dead"
	if(rand_dead eq  1) dmsg "is no more"
	if(rand_dead eq  2) dmsg "has ceased to be"
	if(rand_dead eq  3) dmsg "has expired"
	if(rand_dead eq  4) dmsg "is history"
	if(rand_dead eq  5) dmsg "has been neutralized"
	if(rand_dead eq  6) dmsg "has been annihilated"
	if(rand_dead eq  7) dmsg "has died"
	if(rand_dead eq  8) dmsg "has turned to dust"
	if(rand_dead eq  9) dmsg "has bitten the dust"
	if(rand_dead eq 10) dmsg "has gone"
	if(rand_dead eq 11) dmsg "will come back"
	if(rand_dead eq 12) dmsg "has been obliterated"
	if(rand_dead eq 13) dmsg "has been destroyed"
	if(rand_dead eq 14) dmsg "has been wiped out"
	if(rand_dead eq 15) dmsg "is a stiff"
	if(rand_dead eq 16) dmsg "has passed on"
	if(rand_dead eq 17) dmsg "has been destroyed"
	if(rand_dead eq 18) dmsg "is late"
	if(rand_dead eq 19) dmsg "rests in peace"
	if(rand_dead eq 20) dmsg "is bereft of life"
	if(rand_dead eq 21) dmsg "is deceased"
	if(rand_dead eq 22) dmsg "is demised"
	if(rand_dead >  22) dmsg "is dead"
}
